diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortArrayTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortArrayTagComponent.java
new file mode 100644
index 000000000..3e71cb7e3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortArrayTagComponent.java
@@ -0,0 +1,56 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.ShortArrayTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+public class ShortArrayTagComponent extends ArrayTagComponent<short[]> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/short_array_tag");
+
+    public ShortArrayTagComponent(@NotNull Screen attachedScreen, @NotNull ShortArrayTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + width(mx, my, partialTick), offY + height(mx, my, partialTick), isHovered(mx, my, partialTick) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().length, attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " shorts", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+    }
+
+    @Override
+    public @NotNull String valueToString() {
+        StringBuilder builder = new StringBuilder();
+        short[] shorts = this.tag.getValue();
+        for (int i = 0; i < shorts.length; i++) {
+            if (i != 0) {
+                builder.append(", ");
+            }
+            builder.append(shorts[i]);
+        }
+        return builder.toString();
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) throws Exception {
+        String[] split = valueString.replace(" ", "").split(",");
+        short[] shorts = new short[split.length];
+        for (int i = 0; i < split.length; i++) {
+            shorts[i] = Short.parseShort(split[i]);
+        }
+        this.tag.setValue(shorts);
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortTagComponent.java
new file mode 100644
index 000000000..b7c5af162
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ShortTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.ShortTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class ShortTagComponent extends ValueTagComponent<Short> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/short_tag");
+
+    public ShortTagComponent(@NotNull Screen attachedScreen, @NotNull ShortTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Short.parseShort(valueString));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/StringTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/StringTagComponent.java
new file mode 100644
index 000000000..6cd969b7c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/StringTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.StringTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class StringTagComponent extends ValueTagComponent<String> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/string_tag");
+
+    public StringTagComponent(@NotNull Screen attachedScreen, @NotNull StringTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(valueString);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ValueTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ValueTagComponent.java
new file mode 100644
index 000000000..27bcc7032
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ValueTagComponent.java
@@ -0,0 +1,55 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+public abstract class ValueTagComponent<T> extends AbstractTagComponent<T>{
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public ValueTagComponent(@NotNull Screen attachedScreen, @NotNull Tag<T> tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + width(mx, my, partialTick), offY + height(mx, my, partialTick), isHovered(mx, my, partialTick) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, tag.getValue().toString(), attachedScreen.fontRenderer.getLastEndingX(), offY + 2).call();
+    }
+
+    @Override
+    public void onMouseClick(int mx, int my, int mouseButton, float partialTick) {
+        if (isHovered(mx, my, partialTick)) {
+            if (mouseButton == 0) {
+                attachedScreen.mc.displayScreen(new PopupBuilder(attachedScreen, 400).withTextField("input", valueToString())
+                    .closeOnEsc(0)
+                    .closeOnEnter(0)
+                    .closeOnClickOut(0)
+                    .withOnCloseListener((statusCode, results) -> {
+                        if (statusCode == 0) {
+                            try {
+                                parseValueFromString((String) results.get("input"));
+                            } catch (Exception e) {
+                                LOGGER.error("Failed to parse input '{}' into a '{}'!", results.get("input"), this.tag.getClass().getSimpleName(), e);
+                            }
+                        }
+                    })
+                    .build());
+            }
+        }
+    }
+
+    public @NotNull String valueToString() {
+        return tag.getValue().toString();
+    }
+
+    public abstract void parseValueFromString(@NotNull String valueString) throws Exception;
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 7906d2861..70873e586 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui.options.data;
 
 import com.mojang.logging.LogUtils;
+import com.mojang.nbt.NbtIo;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.enums.EnumGPUVendor;
@@ -11,6 +12,7 @@ import net.minecraft.client.gui.ScreenSoundTest;
 import net.minecraft.client.gui.ScreenTextureViewer;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
+import net.minecraft.client.gui.nbteditor.ScreenNBTEditor;
 import net.minecraft.client.gui.options.components.*;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerControllerSP;
@@ -377,6 +379,13 @@ public abstract class OptionsPages
                     Global.accessor = mc;
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.font_tester", () -> mc.displayScreen(new ScreenFontTest(mc.currentScreen))))
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.nbt_tester", () -> {
+                    try {
+                        mc.displayScreen(new ScreenNBTEditor(mc.currentScreen, "NBT Test", NbtIo.readCompressed(OptionsPages.class.getResourceAsStream("/debug/nbt/allTags_1_0_0.dat")), null));
+                    } catch (IOException e) {
+                        throw new RuntimeException(e);
+                    }
+                }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
                     DataDumper.main(new String[0]);
                     FileOpener.open(new File(mc.getMinecraftDir(), "infodump"));
diff --git a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 9df70381f..798d4721c 100644
--- a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -76,10 +76,10 @@ public class ClientCommandSource implements CommandSource {
     @Override
     public @NotNull Vec3 getBlockCoordinates() {
         if (this.mc.objectMouseOver != null) {
-            return Vec3.getTempVec3(this.mc.objectMouseOver.x, this.mc.objectMouseOver.y, this.mc.objectMouseOver.z);
+            return Vec3.fromPool(this.mc.objectMouseOver.x, this.mc.objectMouseOver.y, this.mc.objectMouseOver.z);
         }
         Vec3 playerCoordinates = this.getCoordinates(true);
-        return Vec3.getTempVec3(MathHelper.floor(playerCoordinates.x), MathHelper.floor(playerCoordinates.y), MathHelper.floor(playerCoordinates.z));
+        return Vec3.fromPool(MathHelper.floor(playerCoordinates.x), MathHelper.floor(playerCoordinates.y), MathHelper.floor(playerCoordinates.z));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index e2ab34b49..cf715c1f8 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -1132,7 +1132,7 @@ public class PacketHandlerClient extends PacketHandler
     {
         NamespaceID id;
         try {
-            id = NamespaceID.getTemp(statisticPacket.statID);
+            id = NamespaceID.fromPool(statisticPacket.statID);
         } catch (HardIllegalArgumentException e) {
             LOGGER.error("Received invalid stat id '{}' from server!", statisticPacket.statID);
             return;
diff --git a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
index 8c6653020..19b3025f6 100644
--- a/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
+++ b/game/client/src/main/java/net/minecraft/client/net/thread/ThreadDownloadResources.java
@@ -33,7 +33,8 @@ public class ThreadDownloadResources extends Thread {
     public final Minecraft mc;
     public File resourcesFolder;
 
-    public volatile boolean downloading = false;
+    public volatile ThreadDownloadState downloading = ThreadDownloadState.IDLE;
+    public volatile long timeOfError = -1;
     public AtomicInteger downloadProgress = new AtomicInteger(0);
     public volatile int toDownload;
 
@@ -68,7 +69,8 @@ public class ThreadDownloadResources extends Thread {
                 try {
                     downloadResources();
                 } catch (Exception e) {
-                    downloading = false;
+                    downloading = ThreadDownloadState.ERROR;
+                    timeOfError = System.currentTimeMillis();
                     LOGGER.error("Error downloading sounds...", e);
                 }
             }
@@ -114,7 +116,7 @@ public class ThreadDownloadResources extends Thread {
             return;
         }
 
-        downloading = true;
+        downloading = ThreadDownloadState.DOWNLOADING;
         toDownload = entries.size();
 
         for (SoundEntry soundEntry : entries) {
@@ -130,7 +132,7 @@ public class ThreadDownloadResources extends Thread {
         this.mc.sndManager = new SoundEngine();
         this.mc.sndManager.init(this.mc.gameSettings);
 
-        downloading = false;
+        downloading = ThreadDownloadState.IDLE;
     }
 
     private String remapDirectory(String path) {
@@ -170,4 +172,10 @@ public class ThreadDownloadResources extends Thread {
             this.size = size;
         }
     }
+
+    public static enum ThreadDownloadState {
+        IDLE,
+        DOWNLOADING,
+        ERROR;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/Lighting.java b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
index 9585a75f5..4e9a23776 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Lighting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/Lighting.java
@@ -38,13 +38,13 @@ public class Lighting {
 		glEnable(GL_COLOR_MATERIAL);
 		glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
 		
-		Vec3 vec = Vec3.getTempVec3(0.2D, 1.0D, -0.7D).normalize();
+		Vec3 vec = Vec3.fromPool(0.2D, 1.0D, -0.7D).normalize();
 		glLightfv(GL_LIGHT0, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
 		glLightfv(GL_LIGHT0, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
 		glLightfv(GL_LIGHT0, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
 		glLightfv(GL_LIGHT0, GL_SPECULAR, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
 		
-		vec = Vec3.getTempVec3(-0.2D, 1.0D, 0.7D).normalize();
+		vec = Vec3.fromPool(-0.2D, 1.0D, 0.7D).normalize();
 		glLightfv(GL_LIGHT1, GL_POSITION, getBuffer(vec.x, vec.y, vec.z, 0.0D));
 		glLightfv(GL_LIGHT1, GL_DIFFUSE, getBuffer(lightBrightness, lightBrightness, lightBrightness, 1.0F));
 		glLightfv(GL_LIGHT1, GL_AMBIENT, getBuffer(0.0F, 0.0F, 0.0F, 1.0F));
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 79e3b2282..3bb772159 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1487,7 +1487,7 @@ public class RenderGlobal
             drawInterpolatedEntityBoundingBox(e, head, camera, partialTicks); // Head
 
             glColor4f(1.0f, 0.0f, 1.0f, 1.0f);
-            final AABB feet = AABB.getTemporaryBB(e.bb.minX, e.y - 0.005, e.bb.minZ, e.bb.maxX, e.y + 0.005, e.bb.maxZ);
+            final AABB feet = AABB.fromPool(e.bb.minX, e.y - 0.005, e.bb.minZ, e.bb.maxX, e.y + 0.005, e.bb.maxZ);
             drawInterpolatedEntityBoundingBox(e, feet, camera, partialTicks); // Feet
 
             glColor4f(0.75f, 0.75f, 1.0f, 1.0f);
@@ -1496,7 +1496,7 @@ public class RenderGlobal
             double lerpOffsetX = MathHelper.lerp(e.xo, e.x, partialTicks) - camera.getX(partialTicks);
             double lerpOffsetY = MathHelper.lerp(e.yo, e.y, partialTicks) - camera.getY(partialTicks);
             double lerpOffsetZ = MathHelper.lerp(e.zo, e.z, partialTicks) - camera.getZ(partialTicks);
-            drawDebugVec(Tessellator.instance, Vec3.getTempVec3(lerpOffsetX, lerpOffsetY + e.getHeadHeight(), lerpOffsetZ), e.getViewVector(partialTicks), 1, 0, 1, 0, 1);
+            drawDebugVec(Tessellator.instance, Vec3.fromPool(lerpOffsetX, lerpOffsetY + e.getHeadHeight(), lerpOffsetZ), e.getViewVector(partialTicks), 1, 0, 1, 0, 1);
             glDisable(GL_TEXTURE_2D);
             GL11.glLineWidth(2);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 4b1b4ccf9..1e62ca44f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -26,7 +26,7 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
     public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
         final float f = 0.375F;
         final float f1 = 0.625F;
-        AABB bounds = AABB.getTemporaryBB(f, 0.0F, f, f1, 1.0F, f1);
+        AABB bounds = AABB.fromPool(f, 0.0F, f, f1, 1.0F, f1);
         renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
         boolean flag1 = false;
         boolean flag2 = false;
@@ -100,18 +100,18 @@ public class BlockModelFence<T  extends BlockLogicFence> extends BlockModelStand
             switch (cube) {
                 // Vertical Beams
                 case 0:
-                    bounds = AABB.getTemporaryBB(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
+                    bounds = AABB.fromPool(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
                     break;
                 case 1:
-                    bounds = AABB.getTemporaryBB(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
+                    bounds = AABB.fromPool(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
                     break;
                 // Horizontal Beams
                 case 2:
-                    bounds = AABB.getTemporaryBB(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
+                    bounds = AABB.fromPool(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
                     break;
                 case 3:
                 default:
-                    bounds = AABB.getTemporaryBB(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
+                    bounds = AABB.fromPool(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
                     break;
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 30eeb51bd..282fc5263 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -365,7 +365,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
         }
         GL11.glRotatef(90, 0, 1, 0);
-        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+        AABB bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
         for(int i1 = 0; i1 < 2; i1++)
         {
             GL11.glPushMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
index 451b907a5..f98e5308b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLever.java
@@ -90,14 +90,14 @@ public class BlockModelLever<T extends BlockLogic> extends BlockModelStandard<T>
         float f8 = 0.0625F;
         float f9 = 0.0625F;
         float f10 = 0.625F;
-        avec3[0] = Vec3.getTempVec3(-f8, 0.0D, -f9);
-        avec3[1] = Vec3.getTempVec3(f8, 0.0D, -f9);
-        avec3[2] = Vec3.getTempVec3(f8, 0.0D, f9);
-        avec3[3] = Vec3.getTempVec3(-f8, 0.0D, f9);
-        avec3[4] = Vec3.getTempVec3(-f8, f10, -f9);
-        avec3[5] = Vec3.getTempVec3(f8, f10, -f9);
-        avec3[6] = Vec3.getTempVec3(f8, f10, f9);
-        avec3[7] = Vec3.getTempVec3(-f8, f10, f9);
+        avec3[0] = Vec3.fromPool(-f8, 0.0D, -f9);
+        avec3[1] = Vec3.fromPool(f8, 0.0D, -f9);
+        avec3[2] = Vec3.fromPool(f8, 0.0D, f9);
+        avec3[3] = Vec3.fromPool(-f8, 0.0D, f9);
+        avec3[4] = Vec3.fromPool(-f8, f10, -f9);
+        avec3[5] = Vec3.fromPool(f8, f10, -f9);
+        avec3[6] = Vec3.fromPool(f8, f10, f9);
+        avec3[7] = Vec3.fromPool(-f8, f10, f9);
         for(int i2 = 0; i2 < 8; i2++)
         {
             if(flag)
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
index a448df03a..db51b879d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPiston.java
@@ -68,17 +68,17 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateWest = 3;
                     renderBlocks.uvRotateSouth = 3;
                     renderBlocks.uvRotateNorth = 3;
-                    bounds = AABB.getTemporaryBB(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.fromPool(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case UP: // '\001'
-                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
+                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
                     break;
 
                 case NORTH: // '\002'
                     renderBlocks.uvRotateSouth = 1;
                     renderBlocks.uvRotateNorth = 2;
-                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.fromPool(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case SOUTH: // '\003'
@@ -86,7 +86,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateNorth = 1;
                     renderBlocks.uvRotateTop = 3;
                     renderBlocks.uvRotateBottom = 3;
-                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
+                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
                     break;
 
                 case WEST: // '\004'
@@ -94,7 +94,7 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateWest = 2;
                     renderBlocks.uvRotateTop = 2;
                     renderBlocks.uvRotateBottom = 1;
-                    bounds = AABB.getTemporaryBB(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    bounds = AABB.fromPool(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
                 case EAST: // '\005'
@@ -102,11 +102,11 @@ public class BlockModelPiston<T extends BlockLogicPistonBase> extends BlockModel
                     renderBlocks.uvRotateWest = 1;
                     renderBlocks.uvRotateTop = 1;
                     renderBlocks.uvRotateBottom = 2;
-                    bounds = AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
+                    bounds = AABB.fromPool(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
                     break;
 
                 default:
-                    bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
+                    bounds = AABB.fromPool(0, 0, 0, 1, 1, 1);
             }
             renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
             renderBlocks.resetRenderBlocks();
